Whamcloud - gitweb
LU-8549 test: optimize restore_and_check_size() in sanity-hsm
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
index 2ec6148..7d0bdf3 100755 (executable)
@@ -11,10 +11,8 @@ SRCDIR=$(dirname $0)
 export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/utils:$PATH:/sbin:/usr/sbin
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test:    3815
-ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 34 35 36"
-# bug number for skipped test:4178         4176
-ALWAYS_EXCEPT="$ALWAYS_EXCEPT 200 221 223b 31a"
+# bug number for skipped test:
+ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
@@ -26,7 +24,7 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
-MCREATE=${MCREATE:-mcreate}
+MMAP_CAT=${MMAP_CAT:-mmap_cat}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
@@ -48,6 +46,14 @@ check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS
 
 build_test_filter
 
+# if there is no CLIENT1 defined, some tests can be ran on localhost
+CLIENT1=${CLIENT1:-$HOSTNAME}
+# if CLIENT2 doesn't exist then use CLIENT1 instead
+# All tests should use CLIENT2 with MOUNT2 only therefore it will work if
+# $CLIENT2 == CLIENT1
+# Exception is the test which need two separate nodes
+CLIENT2=${CLIENT2:-$CLIENT1}
+
 #
 # In order to test multiple remote HSM agents, a new facet type named "AGT" and
 # the following associated variables are added:
@@ -76,8 +82,11 @@ init_agt_vars() {
                exit 0
        fi
 
+       # We used to put the HSM archive in $SHARED_DIRECTORY but that
+       # meant NFS issues could hose sanity-hsm sessions. So now we
+       # use $TMP instead.
        for n in $(seq $AGTCOUNT); do
-               eval export AGTDEV$n=\$\{AGTDEV$n:-"$SHARED_DIRECTORY/arc$n"\}
+               eval export AGTDEV$n=\$\{AGTDEV$n:-"$TMP/arc$n"\}
                agent=CLIENT$((n + 1))
                if [[ -z "${!agent}" ]]; then
                        [[ $CLIENTCOUNT -eq 1 ]] && agent=CLIENT1 ||
@@ -94,7 +103,16 @@ init_agt_vars() {
        export HSMTOOL_EVENT_FIFO=${HSMTOOL_EVENT_FIFO:=""}
        export HSMTOOL_TESTDIR
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
+       # $hsm_root/$HSMTMP Makes $hsm_root dir path less generic to ensure
+       # rm -rf $hsm_root/* is safe even if $hsm_root becomes unset to avoid
+       # deleting everything in filesystem, independent of any copytool.
+       export HSMTMP=${HSMTMP:-"shsm"}
+
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
+
+       [ -z "${HSM_ARCHIVE// /}" ] && error "HSM_ARCHIVE is empty!"
+       HSM_ARCHIVE=$HSM_ARCHIVE/$HSMTMP
+
        HSM_ARCHIVE_NUMBER=2
 
        # The test only support up to 10 MDTs
@@ -103,6 +121,9 @@ init_agt_vars() {
 
        # archive is purged at copytool setup
        HSM_ARCHIVE_PURGE=true
+
+       # Don't allow copytool error upon start/setup
+       HSMTOOL_NOERROR=false
 }
 
 # Get the backend root path for the given agent facet.
@@ -133,15 +154,40 @@ get_mdt_devices() {
 }
 
 search_copytools() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
-       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $hosts "pgrep -x $HSMTOOL_BASE"
 }
 
-search_and_kill_copytool() {
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+kill_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+
+       echo "Killing existing copytools on $hosts"
+       do_nodesv $hosts "killall -q $HSMTOOL_BASE" || true
+}
+
+wait_copytools() {
+       local hosts=${1:-$(facet_active_host $SINGLEAGT)}
+       local wait_timeout=200
+       local wait_start=$SECONDS
+       local wait_end=$((wait_start + wait_timeout))
+
+       while ((SECONDS < wait_end)); do
+               sleep 2
+               if ! search_copytools $hosts; then
+                       echo "copytools stopped in $((SECONDS - wait_start))s"
+                       return 0
+               fi
+
+               echo "copytools still running on $hosts"
+       done
+
+       # try to dump Copytool's stack
+       do_nodesv $hosts "echo 1 >/proc/sys/kernel/sysrq ; " \
+                        "echo t >/proc/sysrq-trigger"
+
+       echo "copytools failed to stop in ${wait_timeout}s"
 
-       echo "Killing existing copytools on $agents"
-       do_nodesv $agents "killall -q $HSMTOOL_BASE" || true
+       return 1
 }
 
 copytool_monitor_setup() {
@@ -170,7 +216,7 @@ copytool_monitor_setup() {
                # Slightly racy, but just making a best-effort to catch obvious
                # problems.
                sleep 1
-               ps -p $HSMTOOL_MONITOR_PDSH >&- ||
+               ps -p $HSMTOOL_MONITOR_PDSH > /dev/null ||
                        error "Failed to start copytool monitor on $agent"
        else
                do_node $agent "$cmd"
@@ -203,27 +249,33 @@ copytool_monitor_cleanup() {
 
 copytool_setup() {
        local facet=${1:-$SINGLEAGT}
-       local lustre_mntpnt=${2:-$MOUNT}
+       # Use MOUNT2 by default if defined
+       local lustre_mntpnt=${2:-${MOUNT2:-$MOUNT}}
        local arc_id=$3
        local hsm_root=${4:-$(copytool_device $facet)}
+
+       [ -z "${hsm_root// /}" ] && error "copytool_setup: hsm_root empty!"
+
        local agent=$(facet_active_host $facet)
 
        if [[ -z "$arc_id" ]] &&
                do_facet $facet "pkill -CONT -x $HSMTOOL_BASE"; then
-                       echo "Wakeup copytool $facet on $agent"
+                       echo "Only wakeup running copytool $facet on $agent"
                        return 0
        fi
 
        if $HSM_ARCHIVE_PURGE; then
                echo "Purging archive on $agent"
-               do_facet $facet "rm -rf $hsm_root/*"
+               do_facet $facet "rm -rf $hsm_root/$HSMTMP/*"
        fi
 
        echo "Starting copytool $facet on $agent"
-       do_facet $facet "mkdir -p $hsm_root" || error "mkdir '$hsm_root' failed"
+       do_facet $facet "mkdir -p $hsm_root/$HSMTMP/" ||
+                       error "mkdir '$hsm_root/$HSMTMP' failed"
        # bandwidth is limited to 1MB/s so the copy time is known and
        # independent of hardware
-       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
+       local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon"
+       cmd+=" --hsm-root $hsm_root/$HSMTMP"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
        [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
                cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
@@ -237,8 +289,13 @@ copytool_setup() {
        [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
        local copytool_log=$prefix.copytool${arc_id}_log.$agent.log
 
-       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1" ||
-               error "start copytool $facet on $agent failed"
+       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1"
+       if [[ $? !=  0 ]]; then
+               [[ $HSMTOOL_NOERROR == true ]] ||
+                       error "start copytool $facet on $agent failed"
+               echo "start copytool $facet on $agent failed"
+       fi
+
        trap cleanup EXIT
 }
 
@@ -255,35 +312,62 @@ get_copytool_event_log() {
 
 copytool_cleanup() {
        trap - EXIT
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
-       local mdtno
-       local idx
-       local oldstate
-       local mdt_hsmctrl
+       local agt_facet=$SINGLEAGT
+       local agt_hosts=${1:-$(facet_active_host $agt_facet)}
+       local hsm_root=$(copytool_device $agt_facet)
 
-       do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
-       sleep 1
-       echo "Copytool is stopped on $agents"
+       [ -z "${hsm_root// /}" ] && error "copytool_cleanup: hsm_root empty!"
 
-       # clean all CDTs orphans requests from previous tests
-       # that would otherwise need to timeout to clear.
-       for mdtno in $(seq 1 $MDSCOUNT); do
-               idx=$(($mdtno - 1))
-               mdt_hsmctrl="mdt.$FSNAME-MDT000${idx}.hsm_control"
-               oldstate=$(do_facet mds${mdtno} "$LCTL get_param -n " \
-                                  "$mdt_hsmctrl")
-               # skip already stop[ed,ing] CDTs
-               echo $oldstate | grep stop && continue
-
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=shutdown"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "stopped" 20 ||
-                       error "mds${mdtno} cdt state is not stopped"
-               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=$oldstate"
-               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
-                       "$oldstate" 20 ||
-                       error "mds${mdtno} cdt state is not $oldstate"
+       local i
+       local facet
+       local param
+       local -a state
+
+       kill_copytools $agt_hosts
+       wait_copytools $agt_hosts || error "copytools failed to stop"
+
+       # Clean all CDTs orphans requests from previous tests that
+       # would otherwise need to timeout to clear.
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+               state[$i]=$(do_facet $facet "$LCTL get_param -n $param")
+
+               # Skip already stopping or stopped CDTs.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               do_facet $facet "$LCTL set_param $param=shutdown"
+       done
+
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check and restore CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               wait_result $facet "$LCTL get_param -n $param" stopped 20 ||
+                       error "$facet CDT state is not stopped"
+
+               # Restore old CDT state.
+               do_facet $facet "$LCTL set_param $param=${state[$i]}"
+       done
+
+       for ((i = 0; i < MDSCOUNT; i++)); do
+               # Only check CDTs that we stopped in the first loop.
+               [[ "${state[$i]}" =~ ^stop ]] && continue
+
+               facet=mds$((i + 1))
+               param=$(printf 'mdt.%s-MDT%04x.hsm_control' $FSNAME $i)
+
+               # Check that the old CDT state was restored.
+               wait_result $facet "$LCTL get_param -n $param" "${state[$i]}" \
+                       20 || error "$facet CDT state is not '${state[$i]}'"
        done
+
+       if do_facet $agt_facet "df $hsm_root" >/dev/null 2>&1 ; then
+               do_facet $agt_facet "rm -rf $hsm_root/$HSMTMP/*"
+       fi
 }
 
 copytool_suspend() {
@@ -311,7 +395,7 @@ make_archive() {
        local file=$HSM_ARCHIVE/$1
        do_facet $SINGLEAGT mkdir -p $(dirname $file)
        do_facet $SINGLEAGT dd if=/dev/urandom of=$file count=32 bs=1000000 ||
-               error "cannot create $file"
+               file_creation_failure dd $file $?
 }
 
 copy2archive() {
@@ -447,6 +531,13 @@ cdt_clear_mount_state() {
 
 cdt_set_mount_state() {
        mdts_set_param "-P" hsm_control "$1"
+       # set_param -P is asynchronous operation and could race with set_param.
+       # In such case configs could be retrieved and applied at mgc after
+       # set_param -P completion. Sleep here to avoid race with set_param.
+       # We need at least 20 seconds. 10 for mgc_requeue_thread to wake up
+       # MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC(5 + 5)
+       # and 10 seconds to retrieve config from server.
+       sleep 20
 }
 
 cdt_check_state() {
@@ -486,17 +577,19 @@ needclients() {
 
 path2fid() {
        $LFS path2fid $1 | tr -d '[]'
+       return ${PIPESTATUS[0]}
 }
 
 get_hsm_flags() {
        local f=$1
        local u=$2
+       local st
 
        if [[ $u == "user" ]]; then
-               local st=$($RUNAS $LFS hsm_state $f)
+               st=$($RUNAS $LFS hsm_state $f)
        else
-               local st=$($LFS hsm_state $f)
                u=root
+               st=$($LFS hsm_state $f)
        fi
 
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed (run as $u)"
@@ -507,7 +600,8 @@ get_hsm_flags() {
 
 get_hsm_archive_id() {
        local f=$1
-       local st=$($LFS hsm_state $f)
+       local st
+       st=$($LFS hsm_state $f)
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed"
 
        local ar=$(echo $st | grep "archive_id" | cut -f5 -d" " |
@@ -531,6 +625,15 @@ check_hsm_flags_user() {
        [[ $st == $fl ]] || error "hsm flags on $f are $st != $fl"
 }
 
+file_creation_failure() {
+       local cmd=$1
+       local f=$2
+       local err=$3
+
+       df $MOUNT $MOUNT2 >&2
+       error "cannot create $f with $cmd, status=$err"
+}
+
 copy_file() {
        local f=
 
@@ -544,20 +647,22 @@ copy_file() {
                f=${f/$DIR/$DIR2}
        fi
        rm -f $f
-       cp $1 $f || error "cannot copy $1 to $f"
+       cp $1 $f || file_creation_failure cp $f $?
+
        path2fid $f || error "cannot get fid on $f"
 }
 
 make_small() {
         local file2=${1/$DIR/$DIR2}
         dd if=/dev/urandom of=$file2 count=2 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
         path2fid $1 || error "cannot get fid on $1"
 }
 
 make_small_sync() {
        dd if=/dev/urandom of=$1 count=1 bs=1M conv=sync ||
-               error "cannot create $1"
+               file_creation_failure dd $1 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -567,53 +672,29 @@ cleanup_large_files() {
        [ $ratio -gt 50 ] && find $MOUNT -size +10M -exec rm -f {} \;
 }
 
-make_large_for_striping() {
-       local file2=${1/$DIR/$DIR2}
-       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
-
-       cleanup_large_files
-
-       dd if=/dev/urandom of=$file2 count=5 bs=$sz conv=fsync ||
-               error "cannot create $file2"
-       path2fid $1 || error "cannot get fid on $1"
-}
-
-make_large_for_progress() {
-       local file2=${1/$DIR/$DIR2}
-
-       cleanup_large_files
-
-       # big file is large enough, so copy time is > 30s
-       # so copytool make 1 progress
-       # size is not a multiple of 1M to avoid stripe
-       # aligment
-       dd if=/dev/urandom of=$file2 count=39 bs=1000000 conv=fsync ||
-               error "cannot create $file2"
-       path2fid $1 || error "cannot get fid on $1"
+check_enough_free_space() {
+       local nb=$1
+       local unit=$2
+       local need=$((nb * unit /1024))
+       local free=$(df -kP $MOUNT | tail -1 | awk '{print $4}')
+       (( $need >= $free )) && return 1
+       return 0
 }
 
-make_large_for_progress_aligned() {
+make_custom_file_for_progress() {
        local file2=${1/$DIR/$DIR2}
+       local fsize=${2:-"39"}
+       local blksz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
+       blksz=${3:-$blksz}
 
-       cleanup_large_files
-
-       # big file is large enough, so copy time is > 30s
-       # so copytool make 1 progress
-       # size is a multiple of 1M to have stripe
-       # aligment
-       dd if=/dev/urandom of=$file2 count=33 bs=1M conv=fsync ||
-               error "cannot create $file2"
-       path2fid $1 || error "cannot get fid on $1"
-}
-
-make_large_for_cancel() {
-       local file2=${1/$DIR/$DIR2}
+       [[ $fsize -gt  0 ]] || error "Invalid file size"
+       [[ $blksz -gt 0 ]] || error "Invalid stripe size"
 
        cleanup_large_files
-
-       # Copy timeout is 100s. 105MB => 105s
-       dd if=/dev/urandom of=$file2 count=103 bs=1M conv=fsync ||
-               error "cannot create $file2"
+       check_enough_free_space $fsize $blksz
+       [ $? != 0 ] && return $?
+       dd if=/dev/zero of=$file2 count=$fsize bs=$blksz conv=fsync ||
+               file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -634,7 +715,7 @@ wait_request_state() {
        local cmd="$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.actions"
        cmd+=" | awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 
-       wait_result $mds "$cmd" $state 100 ||
+       wait_result $mds "$cmd" $state 200 ||
                error "request on $fid is not $state on $mds"
 }
 
@@ -656,8 +737,10 @@ get_request_count() {
 
 wait_all_done() {
        local timeout=$1
+       local fid=$2
 
        local cmd="$LCTL get_param -n $HSM_PARAM.actions"
+       [[ -n $fid ]] && cmd+=" | grep '$fid'"
        cmd+=" | egrep 'WAITING|STARTED'"
 
        wait_result $SINGLEMDS "$cmd" "" $timeout ||
@@ -669,6 +752,11 @@ wait_for_grace_delay() {
        sleep $val
 }
 
+wait_for_loop_period() {
+       local val=$(get_hsm_param loop_period)
+       sleep $val
+}
+
 parse_json_event() {
        local raw_event=$1
 
@@ -681,14 +769,74 @@ parse_json_event() {
        echo $raw_event | python -c "$json_parser"
 }
 
-# populate MDT device array
-get_mdt_devices
+get_agent_by_uuid_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
+                grep $uuid"
+}
+
+check_agent_registered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ ! -z "$agent" ]]; then
+               echo "found agent $agent on $mds"
+       else
+               error "uuid $uuid not found in agent list on $mds"
+       fi
+}
+
+check_agent_unregistered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ -z "$agent" ]]; then
+               echo "uuid not found in agent list on $mds"
+       else
+               error "uuid found in agent list on $mds: $agent"
+       fi
+}
+
+check_agent_registered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_registered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+check_agent_unregistered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+get_agent_uuid() {
+       local agent=${1:-$(facet_active_host $SINGLEAGT)}
+
+       # Lustre mount-point is mandatory and last parameter on
+       # copytool cmd-line.
+       local mntpnt=$(do_rpc_nodes $agent ps -C $HSMTOOL_BASE -o args= |
+                      awk '{print $NF}')
+       [ -n "$mntpnt" ] || error "Found no Agent or with no mount-point "\
+                                 "parameter"
+       do_rpc_nodes $agent get_client_uuid $mntpnt | cut -d' ' -f2
+}
 
 # initiate variables
 init_agt_vars
 
+# populate MDT device array
+get_mdt_devices
+
 # cleanup from previous bad setup
-search_and_kill_copytool
+kill_copytools
 
 # for recovery tests, coordinator needs to be started at mount
 # so force it
@@ -741,6 +889,23 @@ test_1() {
 }
 run_test 1 "lfs hsm flags root/non-root access"
 
+test_1a() {
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_small $f)
+
+       $LFS hsm_archive $f || error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       # Release and check states
+       $LFS hsm_release $f || error "could not release file"
+       echo -n "Verifying released state: "
+       check_hsm_flags $f "0x0000000d"
+
+       $MMAP_CAT $f > /dev/null || error "failed mmap & cat release file"
+}
+run_test 1a "mmap & cat a HSM released file"
+
 test_2() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
@@ -796,7 +961,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/etc/passwd of=$f.append bs=1 count=3\
           conv=notrunc oflag=append status=noxfer ||
-               error "could not append to test file"
+               file_creation_failure dd $f.append $?
        check_hsm_flags $f.append "0x00000003"
 
        # Modify a file sets it dirty
@@ -805,7 +970,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/dev/zero of=$f.modify bs=1 count=3\
           conv=notrunc status=noxfer ||
-               error "could not modify test file"
+               file_creation_failure dd $f.modify $?
        check_hsm_flags $f.modify "0x00000003"
 
        # Open O_TRUNC sets dirty
@@ -852,13 +1017,19 @@ test_8() {
 run_test 8 "Test default archive number"
 
 test_9() {
-       mkdir -p $DIR/$tdir
-       local f=$DIR/$tdir/$tfile
-       local fid=$(copy_file /etc/passwd $f)
        # we do not use the default one to be sure
        local new_an=$((HSM_ARCHIVE_NUMBER + 1))
        copytool_cleanup
        copytool_setup $SINGLEAGT $MOUNT $new_an
+
+       # give time for CT to register with MDTs
+       sleep $(($MDSCOUNT*2))
+       local uuid=$(get_agent_uuid $(facet_active_host $SINGLEAGT))
+       check_agent_registered $uuid
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/passwd $f)
        $LFS hsm_archive --archive $new_an $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -866,7 +1037,7 @@ test_9() {
 
        copytool_cleanup
 }
-run_test 9 "Use of explict archive number, with dedicated copytool"
+run_test 9 "Use of explicit archive number, with dedicated copytool"
 
 test_9a() {
        needclients 3 || return 0
@@ -979,7 +1150,7 @@ test_10d() {
 }
 run_test 10d "Archive a file on the default archive id"
 
-test_11() {
+test_11a() {
        mkdir -p $DIR/$tdir
        copy2archive /etc/hosts $tdir/$tfile
        local f=$DIR/$tdir/$tfile
@@ -1003,7 +1174,31 @@ test_11() {
        local AFILE=$(do_facet $SINGLEAGT ls $HSM_ARCHIVE'/*/*/*/*/*/*/'$fid) ||
                error "fid $fid not in archive $HSM_ARCHIVE"
 }
-run_test 11 "Import a file"
+run_test 11a "Import a file"
+
+test_11b() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+       $LFS hsm_archive -a $HSM_ARCHIVE_NUMBER $f ||
+               error "hsm_archive failed"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       local FILE_HASH=$(md5sum $f)
+       rm -f $f
+
+       import_file $fid $f
+
+       echo "$FILE_HASH" | md5sum -c
+
+       [[ $? -eq 0 ]] || error "Restored file differs"
+
+       copytool_cleanup
+}
+run_test 11b "Import a deleted file using its FID"
 
 test_12a() {
        # test needs a running copytool
@@ -1014,16 +1209,16 @@ test_12a() {
 
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
-       local f=$DIR2/$tdir/$tfile
+       local f2=$DIR2/$tdir/$tfile
        echo "Verifying released state: "
-       check_hsm_flags $f "0x0000000d"
+       check_hsm_flags $f2 "0x0000000d"
 
-       local fid=$(path2fid $f)
-       $LFS hsm_restore $f
+       local fid=$(path2fid $f2)
+       $LFS hsm_restore $f2
        wait_request_state $fid RESTORE SUCCEED
 
        echo "Verifying file state: "
-       check_hsm_flags $f "0x00000009"
+       check_hsm_flags $f2 "0x00000009"
 
        do_facet $SINGLEAGT diff -q $HSM_ARCHIVE/$tdir/$tfile $f
 
@@ -1067,7 +1262,10 @@ test_12c() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        $LFS setstripe -c 2 $f
-       local fid=$(make_large_for_striping $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 5)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local FILE_CRC=$(md5sum $f)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -1294,6 +1492,97 @@ test_12o() {
 }
 run_test 12o "Layout-swap failure during Restore leaves file released"
 
+test_12p() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+       $LFS hsm_release $f || error "cannot release $f"
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+       $LFS hsm_release $f || error "cannot release $f"
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+
+       copytool_cleanup
+}
+run_test 12p "implicit restore of a file on copytool mount point"
+
+cleanup_test_12q() {
+       trap 0
+       zconf_umount $(facet_host $SINGLEAGT) $MOUNT3 ||
+               error "cannot umount $MOUNT3 on $SINGLEAGT"
+}
+
+test_12q() {
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.58) ] &&
+               skip "need MDS version at least 2.7.58" && return 0
+
+       zconf_mount $(facet_host $SINGLEAGT) $MOUNT3 ||
+               error "cannot mount $MOUNT3 on $SINGLEAGT"
+
+       trap cleanup_test_12q EXIT
+
+       # test needs a running copytool
+       copytool_setup $SINGLEAGT $MOUNT3
+
+       mkdir $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local f2=$DIR2/$tdir/$tfile
+       local fid=$(make_small $f)
+       local orig_size=$(stat -c "%s" $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       $LFS hsm_release $f || error "could not release file"
+       check_hsm_flags $f "0x0000000d"
+
+       kill_copytools
+       wait_copytools || error "copytool failed to stop"
+
+       cat $f > /dev/null &
+
+       # wait a bit to allow implicit restore request to be handled.
+       # if not, next stat would also block on layout-lock.
+       sleep 5
+
+       local size=$(stat -c "%s" $f2)
+       [ $size -eq $orig_size ] ||
+               error "$f2: wrong size after archive: $size != $orig_size"
+
+       HSM_ARCHIVE_PURGE=false copytool_setup $SINGLEAGT /mnt/lustre3
+
+       wait
+
+       size=$(stat -c "%s" $f)
+       [ $size -eq $orig_size ] ||
+               error "$f: wrong size after restore: $size != $orig_size"
+
+       size=$(stat -c "%s" $f2)
+       [ $size -eq $orig_size ] ||
+               error "$f2: wrong size after restore: $size != $orig_size"
+
+       :>$f
+
+       size=$(stat -c "%s" $f)
+       [ $size -eq 0 ] ||
+               error "$f: wrong size after overwrite: $size != 0"
+
+       size=$(stat -c "%s" $f2)
+       [ $size -eq 0 ] ||
+               error "$f2: wrong size after overwrite: $size != 0"
+
+       copytool_cleanup
+       zconf_umount $(facet_host $SINGLEAGT) $MOUNT3 ||
+               error "cannot umount $MOUNT3 on $SINGLEAGT"
+}
+run_test 12q "file attributes are refreshed after restore"
+
 test_13() {
        # test needs a running copytool
        copytool_setup
@@ -1439,7 +1728,8 @@ test_16() {
        $LFS hsm_archive $f
        wait_request_state $fid ARCHIVE SUCCEED
        local end=$(date +%s)
-       local duration=$((end - start))
+       # Add 1 to account for rounding errors between start and end (LU-8155)
+       local duration=$((end - start + 1))
 
        [[ $duration -ge $goal ]] ||
                error "Transfer is too fast $duration < $goal"
@@ -1673,8 +1963,7 @@ test_24a() {
        [ $ctime0 -eq $ctime1 ] ||
                error "release changed ctime from $ctime0 to $ctime1"
 
-       # Restore should not change atime or mtime and should not
-       # decrease ctime.
+       # Restore should not change any timestamps.
        $LFS hsm_restore $file
        wait_request_state $fid RESTORE SUCCEED
 
@@ -1688,7 +1977,7 @@ test_24a() {
        [ $mtime0 -eq $mtime1 ] ||
                error "restore changed mtime from $mtime0 to $mtime1"
 
-       [ $ctime0 -le $ctime1 ] ||
+       [ $ctime0 -eq $ctime1 ] ||
                error "restore changed ctime from $ctime0 to $ctime1"
 
        copytool_cleanup
@@ -1707,7 +1996,7 @@ test_24a() {
        [ $mtime0 -eq $mtime1 ] ||
                error "remount changed mtime from $mtime0 to $mtime1"
 
-       [ $ctime0 -le $ctime1 ] ||
+       [ $ctime0 -eq $ctime1 ] ||
                error "remount changed ctime from $ctime0 to $ctime1"
 }
 run_test 24a "Archive, release, and restore does not change a/mtime (i/o)"
@@ -1723,7 +2012,7 @@ test_24b() {
        copytool_setup
        mkdir -p $DIR/$tdir
 
-       # Check that root can do HSM actions on a ordinary user's file.
+       # Check that root can do HSM actions on a regular user's file.
        rm -f $file
        fid=$(make_small $file)
        sum0=$(md5sum $file)
@@ -1801,7 +2090,6 @@ test_24c() {
        chown $RUNAS_ID:nobody $file ||
                error "cannot chown '$file' to '$RUNAS_ID:nobody'"
 
-       set_hsm_param user_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by user should fail"
 
@@ -1815,7 +2103,6 @@ test_24c() {
        chown nobody:$RUNAS_GID $file ||
                error "cannot chown '$file' to 'nobody:$RUNAS_GID'"
 
-       set_hsm_param group_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by group should fail"
 
@@ -1829,7 +2116,6 @@ test_24c() {
        chown nobody:nobody $file ||
                error "cannot chown '$file' to 'nobody:nobody'"
 
-       set_hsm_param other_request_mask ""
        $RUNAS $LFS hsm_$action $file &&
                error "$action by other should fail"
 
@@ -1879,7 +2165,7 @@ test_24d() {
        wait_request_state $fid1 RESTORE SUCCEED
 
        $LFS hsm_release $file1 || error "cannot release '$file1'"
-       dd if=$file2 of=/dev/null bs=1M || "cannot read '$file2'"
+       dd if=$file2 of=/dev/null bs=1M || error "cannot read '$file2'"
 
        $LFS hsm_release $file2 &&
                error "release should fail on read-only mount"
@@ -1889,6 +2175,55 @@ test_24d() {
 }
 run_test 24d "check that read-only mounts are respected"
 
+test_24e() {
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local f=$DIR/$tdir/$tfile
+       local fid
+
+       fid=$(make_small $f) || error "cannot create $f"
+       $LFS hsm_archive $f || error "cannot archive $f"
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "cannot release $f"
+       while ! $LFS hsm_state $f | grep released; do
+               sleep 1
+       done
+
+       tar -cf $TMP/$tfile.tar $DIR/$tdir || error "cannot tar $DIR/$tdir"
+
+       copytool_cleanup
+}
+run_test 24e "tar succeeds on HSM released files" # LU-6213
+
+test_24f() {
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir/d1
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+       sum0=$(md5sum $f)
+       echo $sum0
+       $LFS hsm_archive -a $HSM_ARCHIVE_NUMBER $f ||
+               error "hsm_archive failed"
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "cannot release $f"
+       tar --xattrs -cvf $f.tar -C $DIR/$tdir $tfile
+       rm -f $f
+       sync
+       tar --xattrs -xvf $f.tar -C $DIR/$tdir ||
+               error "Can not recover the tar contents"
+       sum1=$(md5sum $f)
+       echo "Sum0 = $sum0, sum1 = $sum1"
+       [ "$sum0" == "$sum1" ] || error "md5sum mismatch for '$tfile'"
+
+       copytool_cleanup
+}
+run_test 24f "root can archive, release, and restore tar files"
+
 test_25a() {
        # test needs a running copytool
        copytool_setup
@@ -1929,91 +2264,241 @@ test_25b() {
        md5sum $f
        st=$?
 
-       [[ $st == 1 ]] || error "lost file access should failed (returns $st)"
+       [[ $st == 1 ]] || error "lost file access should failed (returns $st)"
+
+       copytool_cleanup
+}
+run_test 25b "Restore lost file (HS_LOST flag) after release"\
+            " (Operation not permitted)"
+
+test_26() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       $LFS hsm_remove $f
+       wait_request_state $fid REMOVE SUCCEED
+
+       check_hsm_flags $f "0x00000000"
+
+       copytool_cleanup
+}
+run_test 26 "Remove the archive of a valid file"
+
+test_27a() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       make_archive $tdir/$tfile
+       local f=$DIR/$tdir/$tfile
+       import_file $tdir/$tfile $f
+       local fid=$(path2fid $f)
+
+       $LFS hsm_remove $f
+
+       [[ $? != 0 ]] || error "Remove of a released file should fail"
+
+       copytool_cleanup
+}
+run_test 27a "Remove the archive of an imported file (Operation not permitted)"
+
+test_27b() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f
+
+       $LFS hsm_remove $f
+
+       [[ $? != 0 ]] || error "Remove of a released file should fail"
+
+       copytool_cleanup
+}
+run_test 27b "Remove the archive of a relased file (Operation not permitted)"
+
+test_28() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       cdt_disable
+       $LFS hsm_remove $f
+
+       rm -f $f
+
+       cdt_enable
+
+       wait_request_state $fid REMOVE SUCCEED
+
+       copytool_cleanup
+}
+run_test 28 "Concurrent archive/file remove"
+
+test_29a() {
+       # Tests --mntpath and --archive options
+
+       local archive_id=7
+       copytool_setup $SINGLEAGT $MOUNT $archive_id
+
+       # Bad archive number
+       $LFS hsm_remove -m $MOUNT -a 33 0x857765760:0x8:0x2 2>&1 |
+               grep "Invalid argument" ||
+               error "unexpected hsm_remove failure (1)"
+
+       # mntpath is present but file is given
+       $LFS hsm_remove --mntpath $MOUNT --archive 30 /qwerty/uyt 2>&1 |
+               grep "hsm: '/qwerty/uyt' is not a valid FID" ||
+               error "unexpected hsm_remove failure (2)"
 
        copytool_cleanup
 }
-run_test 25b "Restore lost file (HS_LOST flag) after release"\
-            " (Operation not permitted)"
+run_test 29a "Tests --mntpath and --archive options"
 
-test_26() {
+test_29b() {
        # test needs a running copytool
        copytool_setup
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid=$(make_small $f)
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
-       $LFS hsm_remove $f
-       wait_request_state $fid REMOVE SUCCEED
+       rm -f $f
 
-       check_hsm_flags $f "0x00000000"
+       $LFS hsm_remove -m $MOUNT -a $HSM_ARCHIVE_NUMBER $fid
+       wait_request_state $fid REMOVE SUCCEED
 
        copytool_cleanup
 }
-run_test 26 "Remove the archive of a valid file"
+run_test 29b "Archive/delete/remove by FID from the archive."
 
-test_27a() {
+test_29c() {
        # test needs a running copytool
        copytool_setup
 
        mkdir -p $DIR/$tdir
-       make_archive $tdir/$tfile
-       local f=$DIR/$tdir/$tfile
-       import_file $tdir/$tfile $f
-       local fid=$(path2fid $f)
+       local fid1=$(make_small $DIR/$tdir/$tfile-1)
+       local fid2=$(make_small $DIR/$tdir/$tfile-2)
+       local fid3=$(make_small $DIR/$tdir/$tfile-3)
 
-       $LFS hsm_remove $f
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $DIR/$tdir/$tfile-[1-3]
+       wait_request_state $fid1 ARCHIVE SUCCEED
+       wait_request_state $fid2 ARCHIVE SUCCEED
+       wait_request_state $fid3 ARCHIVE SUCCEED
 
-       [[ $? != 0 ]] || error "Remove of a released file should fail"
+       rm -f $DIR/$tdir/$tfile-[1-3]
+
+       echo $fid1 > $DIR/$tdir/list
+       echo $fid2 >> $DIR/$tdir/list
+       echo $fid3 >> $DIR/$tdir/list
+
+       $LFS hsm_remove -m $MOUNT -a $HSM_ARCHIVE_NUMBER \
+               --filelist $DIR/$tdir/list
+       wait_request_state $fid1 REMOVE SUCCEED
+       wait_request_state $fid2 REMOVE SUCCEED
+       wait_request_state $fid3 REMOVE SUCCEED
 
        copytool_cleanup
 }
-run_test 27a "Remove the archive of an imported file (Operation not permitted)"
+run_test 29c "Archive/delete/remove by FID, using a file list."
 
-test_27b() {
-       # test needs a running copytool
-       copytool_setup
+test_29d() {
+       # test needs more than one CT
+       needclients 3 || return 0
+
+       local n
+       local file
+       local fid
+
+       copytool_cleanup $(comma_list $(agts_nodes))
+
+       # start all of the copytools
+       for n in $(seq $AGTCOUNT); do
+               copytool_setup agt$n $MOUNT2 $n
+       done
 
+       trap "copytool_cleanup $(comma_list $(agts_nodes))" EXIT
+       # archive files
        mkdir -p $DIR/$tdir
-       local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
-       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       file=$DIR/$tdir/$tfile
+       fid=$(make_small $file)
+
+       $LFS hsm_archive $file
        wait_request_state $fid ARCHIVE SUCCEED
-       $LFS hsm_release $f
+       check_hsm_flags $file "0x00000009"
 
-       $LFS hsm_remove $f
+       rm -f $file
 
-       [[ $? != 0 ]] || error "Remove of a released file should fail"
+       $LFS hsm_remove -a 0 $fid
 
-       copytool_cleanup
-}
-run_test 27b "Remove the archive of a relased file (Operation not permitted)"
+       # give time for CDT to handle remove request and create broadcasted
+       sleep 2
 
-test_28() {
-       # test needs a running copytool
-       copytool_setup
+       # remove request has been broadcasted ?
+       local cnt=$(get_request_count $fid REMOVE)
+       # broadcasted requests + original
+       [[ $cnt -eq $((AGTCOUNT + 1)) ]] ||
+               error "remove not broadcasted to all CTs"
 
-       mkdir -p $DIR/$tdir
-       local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
-       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
-       wait_request_state $fid ARCHIVE SUCCEED
+       # give time for CDT and CTs to handle broadcasted
+       wait_for_loop_period
 
-       cdt_disable
-       $LFS hsm_remove $f
+       # each agent serves one different archive_id, so broadcasted
+       # hsm_remove request should only succeed once and fail at all others
+       local res
+       local scnt=0
+       local fcnt=0
+       for n in $(seq $AGTCOUNT); do
+               res=$(do_facet $SINGLEMDS "$LCTL get_param -n \
+                              $HSM_PARAM.actions | awk \
+                              '/'$fid'.*action=REMOVE archive#='$n'/ \
+                              {print \\\$13}' | cut -f2 -d=")
+               if [[ "$res" == "SUCCEED" ]]; then
+                       scnt=$((scnt + 1))
+               elif [[ "$res" == "FAILED" ]]; then
+                       fcnt=$((fcnt + 1))
+               fi
+       done
 
-       rm -f $f
+       [[ $scnt -ne 1 ]] &&
+               error "one and only CT should have removed successfully"
 
-       cdt_enable
+       [[ $AGTCOUNT -ne $((scnt + fcnt)) ]] &&
+               error "all but one CT should have failed to remove"
 
-       wait_request_state $fid REMOVE SUCCEED
+       trap - EXIT
+       copytool_cleanup $(comma_list $(agts_nodes))
 
-       copytool_cleanup
 }
-run_test 28 "Concurrent archive/file remove"
+run_test 29d "hsm_remove by FID with archive_id 0 for unlinked file cause "\
+            "request to be sent once for each registered archive_id"
 
 test_30a() {
        # restore at exec cannot work on agent node (because of Linux kernel
@@ -2087,6 +2572,7 @@ test_30c() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/SLEEP
+       local slp_sum1=$(md5sum /bin/sleep)
        local fid=$(copy_file /bin/sleep $f)
        chmod 755 $f
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2103,7 +2589,12 @@ test_30c() {
        wait $pid
        [[ $? == 0 ]] || error "Execution failed during run"
        cmp /bin/sleep $f
-       [[ $? == 0 ]] || error "Binary overwritten during exec"
+       if [[ $? != 0 ]]; then
+               local slp_sum2=$(md5sum /bin/sleep)
+               # in case sleep file is modified during the test
+               [[ $slp_sum1 == $slp_sum2 ]] &&
+                       error "Binary overwritten during exec"
+       fi
 
        # cleanup
        # remove no try action mode
@@ -2126,19 +2617,18 @@ restore_and_check_size() {
        while [[ "$st" != "0x00000009" && $cpt -le 10 ]]
        do
                n=$(stat -c "%s" $f)
-               # we echo in both cases to show stat is not
-               # hang
+               # we echo in both cases to show stat is not hang
                if [[ $n != $s ]]; then
                        echo "size seen is $n != $s"
                        err=1
                else
                        echo "size seen is right: $n == $s"
                fi
-               st=$(get_hsm_flags $f)
                sleep 10
                cpt=$((cpt + 1))
+               st=$(get_hsm_flags $f)
        done
-       if [[ $cpt -lt 10 ]]; then
+       if [[ "$st" = "0x00000009" ]]; then
                echo " "done
        else
                echo " restore is too long"
@@ -2176,7 +2666,10 @@ test_31b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2197,7 +2690,10 @@ test_31c() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress_aligned $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 33 1048576)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2218,11 +2714,23 @@ test_33() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
 
+       # to be sure wait_all_done will not be mislead by previous tests
+       # and ops.
+       cdt_purge
+       wait_for_grace_delay
+       # Also raise grace_delay significantly so the Canceled
+       # Restore action will stay enough long avail.
+       local old_grace=$(get_hsm_param grace_delay)
+       set_hsm_param grace_delay 100
+
        md5sum $f >/dev/null &
        local pid=$!
        wait_request_state $fid RESTORE STARTED
@@ -2235,8 +2743,29 @@ test_33() {
 
        $LFS hsm_cancel $f
 
-       wait_request_state $fid RESTORE CANCELED
-       wait_request_state $fid CANCEL SUCCEED
+       # instead of waiting+checking both Restore and Cancel ops
+       # sequentially, wait for both to be finished and then check
+       # each results.
+       wait_all_done 100 $fid
+       local rstate=$(get_request_state $fid RESTORE)
+       local cstate=$(get_request_state $fid CANCEL)
+
+       # restore orig grace_delay.
+       set_hsm_param grace_delay $old_grace
+
+       if [[ "$rstate" == "CANCELED" ]] ; then
+               [[ "$cstate" == "SUCCEED" ]] ||
+                       error "Restore state is CANCELED and Cancel state " \
+                              "is not SUCCEED but $cstate"
+               echo "Restore state is CANCELED, Cancel state is SUCCEED"
+       elif [[ "$rstate" == "SUCCEED" ]] ; then
+               [[ "$cstate" == "FAILED" ]] ||
+                       error "Restore state is SUCCEED and Cancel state " \
+                               "is not FAILED but $cstate"
+               echo "Restore state is SUCCEED, Cancel state is FAILED"
+       else
+               error "Restore state is $rstate and Cancel state is $cstate"
+       fi
 
        [ -z $killed ] ||
                error "Cannot kill process waiting for restore ($killed)"
@@ -2252,7 +2781,10 @@ test_34() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2285,7 +2817,10 @@ test_35() {
 
        local f=$DIR/$tdir/$tfile
        local f1=$DIR/$tdir/$tfile-1
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local fid1=$(copy_file /etc/passwd $f1)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
@@ -2321,7 +2856,10 @@ test_36() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2348,6 +2886,31 @@ test_36() {
 }
 run_test 36 "Move file during restore"
 
+test_37() {
+       # LU-5683: check that an archived dirty file can be rearchived.
+       copytool_cleanup
+       copytool_setup $SINGLEAGT $MOUNT2
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+
+       fid=$(make_small $f) || error "cannot create small file"
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "cannot release $f"
+
+       # Dirty file.
+       dd if=/dev/urandom of=$f bs=1M count=1 || error "cannot dirty file"
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       copytool_cleanup
+}
+run_test 37 "re-archive a dirty file"
+
 multi_archive() {
        local prefix=$1
        local count=$2
@@ -2375,7 +2938,7 @@ test_40() {
        done
        # force copytool to use a local/temp archive dir to ensure best
        # performance vs remote/NFS mounts used in auto-tests
-       if df --local $HSM_ARCHIVE >/dev/null 2>&1 ; then
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
                copytool_setup
        else
                copytool_setup $SINGLEAGT $MOUNT $HSM_ARCHIVE_NUMBER $TMP/$tdir
@@ -2458,7 +3021,7 @@ test_54() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_small $f)
+       local fid=$(make_custom_file_for_progress $f 39 1000000)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2486,7 +3049,7 @@ test_55() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_small $f)
+       local fid=$(make_custom_file_for_progress $f 39 1000000)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2514,7 +3077,9 @@ test_56() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2623,12 +3188,29 @@ test_58() {
 }
 run_test 58 "Truncate a released file will trigger restore"
 
+test_59() {
+       local fid
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -lt $(version_code 2.7.63) ]] &&
+               skip "Need MDS version at least 2.7.63" && return
+
+       copytool_setup
+       $MCREATE $DIR/$tfile || error "mcreate failed"
+       $TRUNCATE $DIR/$tfile 42 || error "truncate failed"
+       $LFS hsm_archive $DIR/$tfile || error "archive request failed"
+       fid=$(path2fid $DIR/$tfile)
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tfile || error "release failed"
+       copytool_cleanup
+}
+run_test 59 "Release stripeless file with non-zero size"
+
 test_60() {
        # This test validates the fix for LU-4512. Ensure that the -u
-       # option changes the progress reporting interval from the default
-       # (30 seconds) to the user-specified interval.
+       # option changes the progress reporting interval from the
+       # default (30 seconds) to the user-specified interval.
        local interval=5
-       local progress_timeout=$((interval * 3))
+       local progress_timeout=$((interval * 4))
 
        # test needs a new running copytool
        copytool_cleanup
@@ -2636,15 +3218,32 @@ test_60() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 10)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       local mdtidx=0
+       local mdt=${MDT_PREFIX}${mdtidx}
+       local mds=mds$((mdtidx + 1))
+
+       # Wait for copytool to register
+       wait_update_facet $mds \
+               "$LCTL get_param -n ${mdt}.hsm.agents | grep -o ^uuid" \
+               uuid 100 || error "coyptool failed to register with $mdt"
 
        local start_at=$(date +%s)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
 
-       local mdtidx=0
-       local mdt=${MDT_PREFIX}${mdtidx}
-       local mds=mds$((mdtidx + 1))
+       local agent=$(facet_active_host $SINGLEAGT)
+       local prefix=$TESTLOG_PREFIX
+       [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
+       local copytool_log=$prefix.copytool_log.$agent.log
+
+
+       wait_update $agent \
+           "grep -o start.copy $copytool_log" "start copy" 100 ||
+               error "copytool failed to start"
 
        local cmd="$LCTL get_param -n ${mdt}.hsm.active_requests"
        cmd+=" | awk '/'$fid'.*action=ARCHIVE/ {print \\\$12}' | cut -f2 -d="
@@ -2671,10 +3270,14 @@ test_60() {
        local elapsed=$((finish_at - start_at))
 
        # Ensure that the progress update occurred within the expected window.
-       if [ $elapsed -lt $interval ]; then
+       if [ $elapsed -lt $((interval - 1)) ]; then
                error "Expected progress update after at least $interval seconds"
        fi
 
+       echo "Wait for on going archive hsm action to complete"
+       wait_update $agent "grep -o copied $copytool_log" "copied" 10 ||
+               echo "File archiving not completed even after 10 secs"
+
        cdt_clear_no_retry
        copytool_cleanup
 }
@@ -2688,6 +3291,13 @@ test_70() {
 
        # Just start and stop the copytool to generate events.
        cdt_clear_no_retry
+
+       # Wait for the copytool to register.
+       wait_update --verbose $(facet_active_host mds1) \
+               "$LCTL get_param -n ${MDT_PREFIX}0.hsm.agents | grep -o ^uuid" \
+               uuid 100 ||
+               error "copytool failed to register with MDT0000"
+
        copytool_cleanup
 
        local REGISTER_EVENT
@@ -2731,7 +3341,9 @@ test_71() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2913,7 +3525,14 @@ test_90() {
                fid=$(copy_file /etc/hosts $f.$i)
                echo $f.$i >> $FILELIST
        done
-       copytool_setup
+       # force copytool to use a local/temp archive dir to ensure best
+       # performance vs remote/NFS mounts used in auto-tests
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
+               copytool_setup
+       else
+               local dai=$(get_hsm_param default_archive_id)
+               copytool_setup $SINGLEAGT $MOUNT $dai $TMP/$tdir
+       fi
        # to be sure wait_all_done will not be mislead by previous tests
        cdt_purge
        wait_for_grace_delay
@@ -3000,7 +3619,10 @@ test_104() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # if cdt is on, it can serve too quickly the request
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER --data $DATA $f
@@ -3041,59 +3663,12 @@ test_105() {
 }
 run_test 105 "Restart of coordinator"
 
-get_agent_by_uuid_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
-                grep $uuid"
-}
-
-check_agent_registered_by_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
-       if [[ ! -z "$agent" ]]; then
-               echo "found agent $agent on $mds"
-       else
-               error "uuid $uuid not found in agent list on $mds"
-       fi
-}
-
-check_agent_unregistered_by_mdt() {
-       local uuid=$1
-       local mdtidx=$2
-       local mds=mds$(($mdtidx + 1))
-       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
-       if [[ -z "$agent" ]]; then
-               echo "uuid not found in agent list on $mds"
-       else
-               error "uuid found in agent list on $mds: $agent"
-       fi
-}
-
-check_agent_registered() {
-       local uuid=$1
-       local mdsno
-       for mdsno in $(seq 1 $MDSCOUNT); do
-               check_agent_registered_by_mdt $uuid $((mdsno - 1))
-       done
-}
-
-check_agent_unregistered() {
-       local uuid=$1
-       local mdsno
-       for mdsno in $(seq 1 $MDSCOUNT); do
-               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
-       done
-}
-
 test_106() {
-       local uuid=$(do_rpc_nodes $(facet_active_host $SINGLEAGT) \
-               get_client_uuid $MOUNT | cut -d' ' -f2)
-
+       # test needs a running copytool
        copytool_setup
+
+       local uuid=$(get_agent_uuid $(facet_active_host $SINGLEAGT))
+
        check_agent_registered $uuid
 
        search_copytools || error "No copytool found"
@@ -3102,6 +3677,7 @@ test_106() {
        check_agent_unregistered $uuid
 
        copytool_setup
+       uuid=$(get_agent_uuid $(facet_active_host $SINGLEAGT))
        check_agent_registered $uuid
 
        copytool_cleanup
@@ -3311,10 +3887,15 @@ test_200() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 103 1048576)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # test with cdt on is made in test_221
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       # wait archive to register at CDT
+       wait_request_state $fid ARCHIVE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid ARCHIVE CANCELED
@@ -3337,6 +3918,8 @@ test_201() {
        # test with cdt on is made in test_222
        cdt_disable
        $LFS hsm_restore $f
+       # wait restore to register at CDT
+       wait_request_state $fid RESTORE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid RESTORE CANCELED
@@ -3352,12 +3935,17 @@ test_202() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
        cdt_disable
        $LFS hsm_remove $f
+       # wait remove to register at CDT
+       wait_request_state $fid REMOVE WAITING
        $LFS hsm_cancel $f
        cdt_enable
        wait_request_state $fid REMOVE CANCELED
@@ -3397,7 +3985,9 @@ test_221() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 103 1048576)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
 
@@ -3504,7 +4094,9 @@ test_223b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3564,7 +4156,9 @@ test_225() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 39 1000000)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3767,7 +4361,9 @@ test_251() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_custom_file_for_progress $f 103 1048576)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        cdt_disable
        # to have a short test
@@ -3779,6 +4375,10 @@ test_251() {
        set_hsm_param loop_period 2
        cdt_enable
 
+       # clear locks to avoid extra delay caused by flush/cancel
+       # and thus prevent early copytool death to timeout.
+       cancel_lru_locks osc
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE STARTED
        sleep 5
@@ -3944,9 +4544,9 @@ test_402() {
        copytool_cleanup
 
        # deactivate all mdc on agent1
-       mdc_change_state $SINGLEAGT "MDT000." "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "deactivate"
 
-       copytool_setup $SINGLEAGT
+       HSMTOOL_NOERROR=true copytool_setup $SINGLEAGT
 
        check_agent_unregistered "uuid" # match any agent
 
@@ -3954,7 +4554,7 @@ test_402() {
        search_copytools $agent && error "Copytool start should have failed"
 
        # reactivate MDCs
-       mdc_change_state $SINGLEAGT "MDT000." "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "activate"
 }
 run_test 402 "Copytool start fails if all MDTs are inactive"
 
@@ -3965,12 +4565,12 @@ test_403() {
        copytool_cleanup
 
         local agent=$(facet_active_host $SINGLEAGT)
-       local uuid=$(do_rpc_nodes $agent get_client_uuid | cut -d' ' -f2)
 
        # deactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
 
        copytool_setup
+       local uuid=$(get_agent_uuid $agent)
        # check the agent is registered on MDT0000, and not on MDT0001
        check_agent_registered_by_mdt $uuid 0
        check_agent_unregistered_by_mdt $uuid 1
@@ -3979,7 +4579,7 @@ test_403() {
        search_copytools $agent || error "No running copytools on $agent"
 
        # reactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
 
        # make sure the copytool is now registered to all MDTs
        check_agent_registered $uuid
@@ -4003,7 +4603,7 @@ test_404() {
        local fid1=$(make_small $dir_mdt0/$tfile)
 
        # deactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
 
        # send an HSM request for files in MDT0000
        $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
@@ -4013,7 +4613,7 @@ test_404() {
                echo "archive successful on mdt0"
 
        # reactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
 
        copytool_cleanup
        # clean test files and directories
@@ -4021,6 +4621,129 @@ test_404() {
 }
 run_test 404 "Inactive MDT does not block requests for active MDTs"
 
+test_405() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local striped_dir=$DIR/$tdir/striped_dir
+
+       # create striped dir on all of MDTs
+       $LFS mkdir -i 0 -c $MDSCOUNT $striped_dir || error "lfs mkdir"
+
+       local fid1=$(make_small_sync $striped_dir/${tfile}_0)
+       local fid2=$(make_small_sync $striped_dir/${tfile}_1)
+       local fid3=$(make_small_sync $striped_dir/${tfile}_2)
+       local fid4=$(make_small_sync $striped_dir/${tfile}_3)
+
+       local idx1=$($LFS getstripe -M $striped_dir/${tfile}_0)
+       local idx2=$($LFS getstripe -M $striped_dir/${tfile}_1)
+       local idx3=$($LFS getstripe -M $striped_dir/${tfile}_2)
+       local idx4=$($LFS getstripe -M $striped_dir/${tfile}_3)
+
+       # check that compound requests are shunt to the rights MDTs
+       $LFS hsm_archive $striped_dir/${tfile}_0 $striped_dir/${tfile}_1  \
+                        $striped_dir/${tfile}_2 $striped_dir/${tfile}_3 ||
+               error "lfs hsm_archive"
+
+       wait_request_state $fid1 ARCHIVE SUCCEED $idx1 &&
+               echo "archive successful on $fid1"
+       wait_request_state $fid2 ARCHIVE SUCCEED $idx2 &&
+               echo "archive successful on $fid2"
+       wait_request_state $fid3 ARCHIVE SUCCEED $idx3 &&
+               echo "archive successful on $fid3"
+       wait_request_state $fid4 ARCHIVE SUCCEED $idx4 &&
+               echo "archive successful on $fid4"
+
+       $LFS hsm_release $striped_dir/${tfile}_0 || error "lfs hsm_release 1"
+       $LFS hsm_release $striped_dir/${tfile}_1 || error "lfs hsm_release 2"
+       $LFS hsm_release $striped_dir/${tfile}_2 || error "lfs hsm_release 3"
+       $LFS hsm_release $striped_dir/${tfile}_3 || error "lfs hsm_release 4"
+
+       cat $striped_dir/${tfile}_0 > /dev/null || error "cat ${tfile}_0 failed"
+       cat $striped_dir/${tfile}_1 > /dev/null || error "cat ${tfile}_1 failed"
+       cat $striped_dir/${tfile}_2 > /dev/null || error "cat ${tfile}_2 failed"
+       cat $striped_dir/${tfile}_3 > /dev/null || error "cat ${tfile}_3 failed"
+
+       copytool_cleanup
+}
+run_test 405 "archive and release under striped directory"
+
+test_406() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+               skip "need MDS version at least 2.7.64" && return 0
+
+       local fid
+       local mdt_index
+
+       copytool_setup
+       mkdir -p $DIR/$tdir
+       fid=$(make_small $DIR/$tdir/$tfile)
+       echo "old fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED
+       $LFS hsm_release $DIR/$tdir/$tfile
+
+       # Should migrate $tdir but not $tfile.
+       $LFS mv -M1 $DIR/$tdir &&
+               error "migrating HSM an archived file should fail"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED
+
+       $LFS hsm_remove $DIR/$tdir/$tfile
+       wait_request_state "$fid" REMOVE SUCCEED
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       $LFS mv -M1 $DIR/$tdir ||
+               error "cannot complete migration after HSM remove"
+
+       mdt_index=$($LFS getstripe -M $DIR/$tdir)
+       if ((mdt_index != 1)); then
+               error "expected MDT index 1, got $mdt_index"
+       fi
+
+       # Refresh fid after migration.
+       fid=$(path2fid $DIR/$tdir/$tfile)
+       echo "new fid $fid"
+
+       $LFS hsm_archive $DIR/$tdir/$tfile
+       wait_request_state "$fid" ARCHIVE SUCCEED 1
+
+       lctl set_param debug=+trace
+       $LFS hsm_release $DIR/$tdir/$tfile ||
+               error "cannot release $DIR/$tdir/$tfile"
+
+       $LFS hsm_restore $DIR/$tdir/$tfile
+       wait_request_state "$fid" RESTORE SUCCEED 1
+
+       cat $DIR/$tdir/$tfile > /dev/null ||
+               error "cannot read $DIR/$tdir/$tfile"
+
+       copytool_cleanup
+}
+run_test 406 "attempting to migrate HSM archived files is safe"
+
+test_500()
+{
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&
+               skip "HSM migrate is not supported" && return
+
+       # Stop the existing copytool
+       copytool_cleanup
+
+       test_mkdir -p $DIR/$tdir
+       llapi_hsm_test -d $DIR/$tdir || error "One llapi HSM test failed"
+}
+run_test 500 "various LLAPI HSM tests"
+
 copytool_cleanup
 
 complete $SECONDS